Infrastructure d’hébergement SaaS
---------------------------------


L’infrastructure d’hébergement proposée par Entr’ouvert utilise les
techniques suivantes :

-   des machines physiques au matériel redondant (alimentation double,
    disques durs RAID 1) avec de très importantes capacités CPU (au
    moins 16 coeurs) et mémoire vive (au moins 128Go) : ces machines
    sont capables de supporter sans délai des montées en charges
    brusques ;
-   ces machines disposent de disques ultra-rapides (SSD) pour fournir
    des espaces disques locaux véloces si nécessaire (espace système,
    espaces temporaires) ; ainsi que de disques rapides (SAS ou SATA)
    pour des espaces de stockages locaux importants (backups locaux,
    fichiers transitoires) ;
-   des machines virtuelles basées sur un système de container (OpenVZ,
    en migration vers lxc) permettant de dimensionner la puissance CPU
    ou la mémoire vive de chaque machine *à chaud* ;
-   des espaces disques obtenus par NFSv3 depuis un SAN, permettant un
    redimensionnement à chaud des volumes disque ; par ailleurs le SAN
    utilise la technologie ZFS avec des *snapshots* horaire, quotidien
    et hebdomadaires ;
-   les machines virtuelles utilisent des IP virtuelles (« failover »)
    qui peuvent être déplacées en quelques minutes vers une autre
    machine physique, et ainsi ne pas nécessiter de modification DNS en
    cas de déplacement des VM.

En terme de sécurité de données :

-   En plus des snapshots ZFS, des backups incrémentaux (quotidiens) et
    complets (hebdomadaires) sont effectués sur une machine isolée hors
    site ;
-   Le système de restauration est régulièrement vérifié ;
-   La duplication d’une machine ou son transport vers un autre hôte
    physique peut être effectuée en quelques minutes (modulo propagation
    des IP fail-over) ;
-   Le serveur PostgreSQL est une machine à disque RAID-5,
    sauvegardée quotidiennement. Elle est secondée d’une machine
    « slave » capable de prendre le relais en cas de défaillance.

En terme de sécurité réseau :

-   Un pare-feu est présent sur chaque machine physique, en entrée comme
    en sortie. En dehors des accès HTTPS aux briques applicatives, tous
    les flux sont filtrés par défaut et ouvert uniquement au cas par
    cas ;
-   Une surveillance « fail-to-ban » coupe les IP qui tentent des
    connexions non autorisées ;
-   L’hébergeur des machines physiques assure par ailleurs une
    protection anti-DDOS.

Un serveur de log externe regroupe tous les événements de toutes les
installations.

Une supervision générale est assurée par des agents SNMP et NRPE qui
remontent les informations sur une plateforme Nagios et alertent les
travailleurs d’Entr’ouvert en temps réel.

![Logo Publik](images/saas.png)
