# Configuration des dépôts logiciels

## Vue générale

Les différents composants logiciels utilisés par Publik proviennent, par
ordre de préférence :

-   de la distribution Debian GNU/Linux stable
-   des *backports* officiels Debian, disposant du suivi de sécurité par
    l’équipe Debian,
-   des paquets Debian fournis et maintenus par les projets *upstream,*
-   de paquets Debian maintenus par Entr’ouvert qui en assure le suivi
    de sécurité.

## Configuration des dépôts logiciels

Les machines doivent disposer des dépôts **jessie** et
**jessie-backports**.

Ajoutons aussi les dépôts Entr'ouvert et RabbitMQ par la création de
*/etc/apt/sources.list.d/eo-prod.list :*

    deb http://deb.entrouvert.org/ jessie main
    deb http://www.rabbitmq.com/debian/ testing main

Ajoutons les clés correspondantes :

    wget -O- https://deb.entrouvert.org/entrouvert.gpg | apt-key add -
    wget -O- https://www.rabbitmq.com/rabbitmq-release-signing-key.asc | apt-key add -
    apt update

Pricisons les paquets qu'on veut tirer de jessie-backports en éditant
*/etc/apt/preferences.d/backports :*

    Package: python-django
    Pin: release a=jessie-backports
    Pin-Priority: 900

    Package: python-django-common
    Pin: release a=jessie-backports
    Pin-Priority: 900

    Package: gunicorn
    Pin: release a=jessie-backports
    Pin-Priority: 900

    Package: python-pyasn1
    Pin: release a=jessie-backports
    Pin-Priority: 900

    Package: python-requests
    Pin: release a=jessie-backports
    Pin-Priority: 900

    Package: python-urllib3
    Pin: release a=jessie-backports
    Pin-Priority: 900

    Package: python-cryptography
    Pin: release a=jessie-backports
    Pin-Priority: 900

    Package: python-ndg-httpsclient
    Pin: release a=jessie-backports
    Pin-Priority: 900

    Package: python-openssl
    Pin: release a=jessie-backports
    Pin-Priority: 900

    Package: python-jwcrypto
    Pin: release a=jessie-backports
    Pin-Priority: 900

    Package: python-setuptools
    Pin: release a=jessie-backports
    Pin-Priority: 900

    Package: python-pkg-resources
    Pin: release a=jessie-backports
    Pin-Priority: 900

## Installation des paquets de base

Outillage utile pour l'installation et plus tard pour le support et la
maintenance :

    apt install postgresql-client # pour création utilisateurs et bases de données dans postgresql
    apt install bsd-mailx # pour test de l'envoi de mails
    apt install zip # pour la création du squelette de site w.c.s.
    apt install curl wget # pour les tests/debug locaux
    apt install ipython ltrace strace psmisc tcpdump tshark locate # pour des debug applicatifs
    apt install ca-certificates-entrouvert # connexion au LDAP EO

Composants additionnels nécessaires pour les applications :

    apt install libreoffice # pour génération de documents dans wcs
    apt install publik-base-theme # système de thème
